diff -bruN freeswan-1.9.orig/klips/net/ipsec/ipsec_init.c freeswan-1.9/klips/net/ipsec/ipsec_init.c
--- freeswan-1.9.orig/klips/net/ipsec/ipsec_init.c	Mon Feb 26 19:50:59 2001
+++ freeswan-1.9/klips/net/ipsec/ipsec_init.c	Mon Jun  4 12:54:13 2001
@@ -14,7 +14,7 @@
  * for more details.
  */
 
-char ipsec_init_c_version[] = "RCSID $Id: ipsec_init.c,v 1.63.2.1 2001/02/27 00:50:59 henry Exp $";
+char ipsec_init_c_version[] = "RCSID $Id: ipsec_init.c,v 1.68 2001/05/29 05:14:36 rgb Exp $";
 
 #include <linux/config.h>
 #include <linux/version.h>
@@ -100,9 +100,12 @@
 #endif /* CONFIG_IPSEC_DEBUG */
 
 	KLIPS_PRINT(debug_tunnel & DB_TN_PROCFS,
-		    "klips_debug:ipsec_eroute_get_info: buffer=0x%p,"
-		    " *start=0x%x, offset=%d, length=%d\n",
-		    buffer, (u_int)*start, (int)offset, length);
+		    "klips_debug:ipsec_eroute_get_info: "
+		    "buffer=0x%p, *start=0x%x, offset=%d, length=%d\n",
+		    buffer,
+		    (u_int)*start,
+		    (int)offset,
+		    length);
 
 	spin_lock_bh(&eroute_lock);
 
@@ -140,16 +143,19 @@
 	size_t sa_len;
 
 	KLIPS_PRINT(debug_tunnel & DB_TN_PROCFS,
-		    "klips_debug:ipsec_spi_get_info: buffer=0x%p,"
-		    "*start=0x%x, offset=%d, length=%d\n",
-		    buffer, (u_int)*start, (int)offset, length);
+		    "klips_debug:ipsec_spi_get_info: "
+		    "buffer=0x%p, *start=0x%x, offset=%d, length=%d\n",
+		    buffer,
+		    (u_int)*start,
+		    (int)offset,
+		    length);
 	
 	spin_lock_bh(&tdb_lock);
 	
 	for (i = 0; i < TDB_HASHMOD; i++) {
 		for (tdbp = tdbh[i]; tdbp; tdbp = tdbp->tdb_hnext) {
 			sa_len = satoa(tdbp->tdb_said, 0, sa, SATOA_BUF);
-			len += sprintf(buffer + len, "%s ", sa);
+			len += sprintf(buffer + len, "%s ", sa_len ? sa : " (error)");
 			len += sprintf(buffer + len, "%s%s%s", TDB_XFORM_NAME(tdbp));
 			len += sprintf(buffer + len, ": dir=%s",
 				       (tdbp->tdb_flags & EMT_INBOUND) ?
@@ -381,9 +387,12 @@
 	size_t sa_len;
 
 	KLIPS_PRINT(debug_tunnel & DB_TN_PROCFS,
-		    "klips_debug:ipsec_spigrp_get_info: buffer=0x%p,"
-		    " *start=0x%x, offset=%d, length=%d\n",
-		    buffer, (u_int)*start, (int)offset, length);
+		    "klips_debug:ipsec_spigrp_get_info: "
+		    "buffer=0x%p, *start=0x%x, offset=%d, length=%d\n",
+		    buffer,
+		    (u_int)*start,
+		    (int)offset,
+		    length);
 
 	spin_lock_bh(&tdb_lock);
 	
@@ -396,7 +405,7 @@
 				while(tdbp2) {
 					sa_len = satoa(tdbp2->tdb_said, 0, sa, SATOA_BUF);
 					len += sprintf(buffer + len, "%s ",
-						       sa);
+						       sa_len ? sa : " (error)");
 					tdbp2 = tdbp2->tdb_onext;
 				}
 				len += sprintf(buffer + len, "\n");
@@ -440,9 +449,12 @@
 	struct ipsecpriv *priv;
 
 	KLIPS_PRINT(debug_tunnel & DB_TN_PROCFS,
-		    "klips_debug:ipsec_tncfg_get_info: buffer=0x%p,"
-		    "*start=0x%x, offset=%d, length=%d\n",
-		    buffer, (u_int)*start, (int)offset, length);
+		    "klips_debug:ipsec_tncfg_get_info: "
+		    "buffer=0x%p, *start=0x%x, offset=%d, length=%d\n",
+		    buffer,
+		    (u_int)*start,
+		    (int)offset,
+		    length);
 
 	for(i = 0; i < IPSEC_NUM_IF; i++) {
 		sprintf(name, "ipsec%d", i);
@@ -455,8 +467,10 @@
 				privdev = (struct device *)(priv->dev);
 				len += sprintf(buffer + len, " -> %s",
 					       privdev ? privdev->name : "NULL");
-				len += sprintf(buffer + len, " mtu=%d -> %d",
-					       /* priv */ dev->mtu, privdev ? privdev->mtu : 0);
+				len += sprintf(buffer + len, " mtu=%d(%d) -> %d",
+					       dev->mtu,
+					       priv->mtu,
+					       privdev ? privdev->mtu : 0);
 			} else {
 				KLIPS_PRINT(debug_tunnel & DB_TN_PROCFS,
 					    "klips_debug:ipsec_tncfg_get_info: device '%s' has no private data space!\n",
@@ -497,7 +511,10 @@
 	KLIPS_PRINT(debug_tunnel & DB_TN_PROCFS,
 		    "klips_debug:ipsec_version_get_info: "
 		    "buffer=0x%p, *start=0x%x, offset=%d, length=%d\n",
-		    buffer, (u_int)*start, (int)offset, length);
+		    buffer,
+		    (u_int)*start,
+		    (int)offset,
+		    length);
 
 	len += sprintf(buffer + len, "FreeS/WAN version: %s\n", freeswan_version);
 #if 0
@@ -541,9 +558,12 @@
 	off_t begin = 0;
 
 	KLIPS_PRINT(debug_tunnel & DB_TN_PROCFS,
-		    "klips_debug:ipsec_klipsdebug_get_info: buffer=0x%p,"
-		    "*start=0x%x, offset=%d, length=%d\n",
-		    buffer, (u_int)*start, (int)offset, length);
+		    "klips_debug:ipsec_klipsdebug_get_info: "
+		    "buffer=0x%p, *start=0x%x, offset=%d, length=%d\n",
+		    buffer,
+		    (u_int)*start,
+		    (int)offset,
+		    length);
 
 	len += sprintf(buffer + len, "debug_tunnel=%08x.\n", debug_tunnel);
 	len += sprintf(buffer + len, "debug_netlink=%08x.\n", debug_netlink);
@@ -655,22 +675,22 @@
 #ifdef CONFIG_PROC_FS
 #  ifndef PROC_FS_2325
 #    ifdef PROC_FS_21
-	proc_register(proc_net, &ipsec_eroute);
-	proc_register(proc_net, &ipsec_spi);
-	proc_register(proc_net, &ipsec_spigrp);
-	proc_register(proc_net, &ipsec_tncfg);
-	proc_register(proc_net, &ipsec_version);
+	error |= proc_register(proc_net, &ipsec_eroute);
+	error |= proc_register(proc_net, &ipsec_spi);
+	error |= proc_register(proc_net, &ipsec_spigrp);
+	error |= proc_register(proc_net, &ipsec_tncfg);
+	error |= proc_register(proc_net, &ipsec_version);
 #      ifdef CONFIG_IPSEC_DEBUG
-	proc_register(proc_net, &ipsec_klipsdebug);
+	error |= proc_register(proc_net, &ipsec_klipsdebug);
 #      endif /* CONFIG_IPSEC_DEBUG */
 #    else /* PROC_FS_21 */
-	proc_register_dynamic(&proc_net, &ipsec_eroute);
-	proc_register_dynamic(&proc_net, &ipsec_spi);
-	proc_register_dynamic(&proc_net, &ipsec_spigrp);
-	proc_register_dynamic(&proc_net, &ipsec_tncfg);
-	proc_register_dynamic(&proc_net, &ipsec_version);
+	error |= proc_register_dynamic(&proc_net, &ipsec_eroute);
+	error |= proc_register_dynamic(&proc_net, &ipsec_spi);
+	error |= proc_register_dynamic(&proc_net, &ipsec_spigrp);
+	error |= proc_register_dynamic(&proc_net, &ipsec_tncfg);
+	error |= proc_register_dynamic(&proc_net, &ipsec_version);
 #      ifdef CONFIG_IPSEC_DEBUG
-	proc_register_dynamic(&proc_net, &ipsec_klipsdebug);
+	error |= proc_register_dynamic(&proc_net, &ipsec_klipsdebug);
 #      endif /* CONFIG_IPSEC_DEBUG */
 #    endif /* PROC_FS_21 */
 #  else /* !PROC_FS_2325 */
@@ -685,7 +705,8 @@
 #  endif /* !PROC_FS_2325 */
 #endif          /* CONFIG_PROC_FS */
 
-	printk("IPsec: KLIPS startup, FreeS/WAN version: %s\n",
+	printk("klips_debug:ipsec_init: "
+	       "KLIPS startup, FreeS/WAN IPSec version: %s\n",
 	       freeswan_version);
 
 #ifndef SPINLOCK
@@ -698,7 +719,7 @@
 
 	error |= pfkey_init();
 
-	register_netdevice_notifier(&ipsec_dev_notifier);
+	error |= register_netdevice_notifier(&ipsec_dev_notifier);
 
 #ifdef CONFIG_IPSEC_ESP
 	inet_add_protocol(&esp_protocol);
@@ -733,53 +754,66 @@
         ipsec_sysctl_unregister();
 #endif                                                                          
 	KLIPS_PRINT(debug_netlink, /* debug_tunnel & DB_TN_INIT, */
-		    "klips_debug:ipsec_cleanup: calling ipsec_tunnel_cleanup_devices.\n");
+		    "klips_debug:ipsec_cleanup: "
+		    "calling ipsec_tunnel_cleanup_devices.\n");
 	error |= ipsec_tunnel_cleanup_devices();
 
 #if 0
 #ifdef CONFIG_IPSEC_IPCOMP
   if (inet_del_protocol(&comp_protocol) < 0)
-    printk(KERN_INFO "klips_debug:ipsec_cleanup:comp close: can't remove protocol\n");
+		printk(KERN_INFO "klips_debug:ipsec_cleanup: "
+		       "comp close: can't remove protocol\n");
 #endif
 #endif
 #ifdef CONFIG_IPSEC_AH
-	if ( inet_del_protocol(&ah_protocol) < 0 )
-		printk(KERN_INFO "klips_debug:ipsec_cleanup:ah close: can't remove protocol\n");
+	if (inet_del_protocol(&ah_protocol) < 0)
+		printk(KERN_INFO "klips_debug:ipsec_cleanup: "
+		       "ah close: can't remove protocol\n");
 #endif /* CONFIG_IPSEC_AH */
 #ifdef CONFIG_IPSEC_ESP
-	if ( inet_del_protocol(&esp_protocol) < 0 )
-		printk(KERN_INFO "klips_debug:ipsec_cleanup:esp close: can't remove protocol\n");
+	if (inet_del_protocol(&esp_protocol) < 0)
+		printk(KERN_INFO "klips_debug:ipsec_cleanup: "
+		       "esp close: can't remove protocol\n");
 #endif /* CONFIG_IPSEC_ESP */
 
-	unregister_netdevice_notifier(&ipsec_dev_notifier);
+	error |= unregister_netdevice_notifier(&ipsec_dev_notifier);
 
 	KLIPS_PRINT(debug_netlink, /* debug_tunnel & DB_TN_INIT, */
-		    "klips_debug:ipsec_cleanup: calling ipsec_tdbcleanup.\n");
+		    "klips_debug:ipsec_cleanup: "
+		    "calling ipsec_tdbcleanup.\n");
 	error |= ipsec_tdbcleanup(0);
 	KLIPS_PRINT(debug_netlink, /* debug_tunnel & DB_TN_INIT, */
-		    "klips_debug:ipsec_cleanup: calling ipsec_radijcleanup.\n");
+		    "klips_debug:ipsec_cleanup: "
+		    "calling ipsec_radijcleanup.\n");
 	error |= ipsec_radijcleanup();
 	
 	KLIPS_PRINT(debug_pfkey, /* debug_tunnel & DB_TN_INIT, */
-		    "klips_debug:ipsec_cleanup: calling pfkey_cleanup.\n");
+		    "klips_debug:ipsec_cleanup: "
+		    "calling pfkey_cleanup.\n");
 	error |= pfkey_cleanup();
 
 #ifdef CONFIG_PROC_FS
 #  ifndef PROC_FS_2325
 #    ifdef CONFIG_IPSEC_DEBUG
 	if (proc_net_unregister(ipsec_klipsdebug.low_ino) != 0)
-		printk("klips_debug:ipsec_cleanup: cannot unregister /proc/net/ipsec_klipsdebug\n");
+		printk("klips_debug:ipsec_cleanup: "
+		       "cannot unregister /proc/net/ipsec_klipsdebug\n");
 #    endif /* CONFIG_IPSEC_DEBUG */
 	if (proc_net_unregister(ipsec_version.low_ino) != 0)
-		printk("klips_debug:ipsec_cleanup: cannot unregister /proc/net/ipsec_version\n");
+		printk("klips_debug:ipsec_cleanup: "
+		       "cannot unregister /proc/net/ipsec_version\n");
 	if (proc_net_unregister(ipsec_eroute.low_ino) != 0)
-		printk("klips_debug:ipsec_cleanup: cannot unregister /proc/net/ipsec_eroute\n");
+		printk("klips_debug:ipsec_cleanup: "
+		       "cannot unregister /proc/net/ipsec_eroute\n");
 	if (proc_net_unregister(ipsec_spi.low_ino) != 0)
-		printk("klips_debug:ipsec_cleanup: cannot unregister /proc/net/ipsec_spi\n");
+		printk("klips_debug:ipsec_cleanup: "
+		       "cannot unregister /proc/net/ipsec_spi\n");
 	if (proc_net_unregister(ipsec_spigrp.low_ino) != 0)
-		printk("klips_debug:ipsec_cleanup: cannot unregister /proc/net/ipsec_spigrp\n");
+		printk("klips_debug:ipsec_cleanup: "
+		       "cannot unregister /proc/net/ipsec_spigrp\n");
 	if (proc_net_unregister(ipsec_tncfg.low_ino) != 0)
-		printk("klips_debug:ipsec_cleanup: cannot unregister /proc/net/ipsec_tncfg\n");
+		printk("klips_debug:ipsec_cleanup: "
+		       "cannot unregister /proc/net/ipsec_tncfg\n");
 #  else /* !PROC_FS_2325 */
 #    ifdef CONFIG_IPSEC_DEBUG
 	proc_net_remove ("ipsec_klipsdebug");
@@ -812,11 +846,13 @@
 	int error = 0;
 
 	KLIPS_PRINT(debug_netlink, /* debug_tunnel & DB_TN_INIT, */
-		    "klips_debug:cleanup_module: calling ipsec_cleanup.\n");
+		    "klips_debug:cleanup_module: "
+		    "calling ipsec_cleanup.\n");
 
 	error |= ipsec_cleanup();
 
-	KLIPS_PRINT(1, "klips_debug:cleanup_module: ipsec module unloaded.\n");
+	KLIPS_PRINT(1, "klips_debug:cleanup_module: "
+		    "ipsec module unloaded.\n");
 
 	return error;
 }
@@ -824,8 +860,21 @@
 
 /*
  * $Log: ipsec_init.c,v $
- * Revision 1.63.2.1  2001/02/27 00:50:59  henry
- * message improvements
+ * Revision 1.68  2001/05/29 05:14:36  rgb
+ * Added PMTU to /proc/net/ipsec_tncfg output.  See 'man 5 ipsec_tncfg'.
+ *
+ * Revision 1.67  2001/05/04 16:34:52  rgb
+ * Rremove erroneous checking of return codes for proc_net_* in 2.4.
+ *
+ * Revision 1.66  2001/05/03 19:40:34  rgb
+ * Check error return codes in startup and shutdown.
+ *
+ * Revision 1.65  2001/02/28 05:03:27  rgb
+ * Clean up and rationalise startup messages.
+ *
+ * Revision 1.64  2001/02/27 22:24:53  rgb
+ * Re-formatting debug output (line-splitting, joining, 1arg/line).
+ * Check for satoa() return codes.
  *
  * Revision 1.63  2000/11/29 20:14:06  rgb
  * Add src= to the output of /proc/net/ipsec_spi and delete dst from IPIP.
diff -bruN freeswan-1.9.orig/klips/net/ipsec/ipsec_netlink.c freeswan-1.9/klips/net/ipsec/ipsec_netlink.c
--- freeswan-1.9.orig/klips/net/ipsec/ipsec_netlink.c	Sun Nov  5 23:32:08 2000
+++ freeswan-1.9/klips/net/ipsec/ipsec_netlink.c	Mon Jun  4 11:34:31 2001
@@ -14,7 +14,7 @@
  * for more details.
  */
 
-char ipsec_netlink_c_version[] = "RCSID $Id: ipsec_netlink.c,v 1.47 2000/11/06 04:32:08 rgb Exp $";
+char ipsec_netlink_c_version[] = "RCSID $Id: ipsec_netlink.c,v 1.48 2001/02/27 22:24:54 rgb Exp $";
 
 #include <linux/config.h>
 #include <linux/version.h>
@@ -93,23 +93,31 @@
 #ifdef CONFIG_IPSEC_DEBUG
 	struct eroute *eret;
 	char sa[SATOA_BUF];
+	size_t sa_len;
 
 
-	satoa(em->em_said, 0, sa, SATOA_BUF);
+	sa_len = satoa(em->em_said, 0, sa, SATOA_BUF);
 
 	if(debug_netlink) {
-		printk("klips_debug:ipsec_callback: skb=0x%p skblen=%ld em_magic=%d em_type=%d\n",
-		       skb, (unsigned long int)skb->len, em->em_magic, em->em_type);
+		printk("klips_debug:ipsec_callback: "
+		       "skb=0x%p skblen=%ld em_magic=%d em_type=%d\n",
+		       skb,
+		       (unsigned long int)skb->len,
+		       em->em_magic,
+		       em->em_type);
 		switch(em->em_type) {
 		case EMT_SETDEBUG:
-			printk("klips_debug:ipsec_callback: set ipsec_debug level\n");
+			printk("klips_debug:ipsec_callback: "
+			       "set ipsec_debug level\n");
 			break;
 		case EMT_DELEROUTE:
 		case EMT_CLREROUTE:
 		case EMT_CLRSPIS:
 			break;
 		default:
-			printk("klips_debug:ipsec_callback: called for SA:%s\n", sa);
+			printk("klips_debug:ipsec_callback: "
+			       "called for SA:%s\n",
+			       sa_len ? sa : " (error)");
 		}
 	}
 #endif /* CONFIG_IPSEC_DEBUG */
@@ -120,7 +128,8 @@
 
 	/*	em = (struct encap_msghdr *)dat; */
 	if (em->em_magic != EM_MAGIC) {
-		printk("klips_debug:ipsec_callback: bad magic=%d failed, should be %d\n",
+		printk("klips_debug:ipsec_callback: "
+		       "bad magic=%d failed, should be %d\n",
 		       em->em_magic,
 		       EM_MAGIC);
 		SENDERR(EINVAL);
@@ -157,7 +166,8 @@
 			debug_pfkey   &= em->em_db_ky;
 		}
 #else /* CONFIG_IPSEC_DEBUG */
-		printk("klips_debug:ipsec_callback: debugging not enabled\n");
+		printk("klips_debug:ipsec_callback: "
+		       "debugging not enabled\n");
 		SENDERR(EINVAL);
 #endif /* CONFIG_IPSEC_DEBUG */
 		break;
@@ -205,22 +215,26 @@
 				tdbp->tdb_flags |= EMT_INBOUND;
 			}
 			KLIPS_PRINT(debug_netlink & DB_NL_TDBCB,
-				    "klips_debug:ipsec_callback: existing Tunnel Descriptor Block not found (this\n"
-				    "klips_debug:                is good) for SA: %s, %s-bound, allocating.\n",
-				    sa, (tdbp->tdb_flags & EMT_INBOUND) ? "in" : "out");
+				    "klips_debug:ipsec_callback: "
+				    "existing Tunnel Descriptor Block not found (this is good) for SA: %s, %s-bound, allocating.\n",
+				    sa_len ? sa : " (error)",
+				    (tdbp->tdb_flags & EMT_INBOUND) ? "in" : "out");
 
 /* XXX  		tdbp->tdb_rcvif = &(enc_softc[em->em_if].enc_if);*/
 			tdbp->tdb_rcvif = NULL;
 		} else {
 			KLIPS_PRINT(debug_netlink & DB_NL_TDBCB,
-				    "klips_debug:ipsec_callback: EMT_SETSPI found an old Tunnel Descriptor Block\n"
-				    "klips_debug:                for SA: %s, delete it first.\n", sa);
+				    "klips_debug:ipsec_callback: "
+				    "EMT_SETSPI found an old Tunnel Descriptor Block for SA: %s, delete it first.\n",
+				    sa_len ? sa : " (error)");
 			SENDERR(EEXIST);
 		}
 		
 		if ((error = tdb_init(tdbp, em))) {
 			KLIPS_PRINT(debug_netlink & DB_NL_TDBCB,
-				    "klips_debug:ipsec_callback: EMT_SETSPI not successful for SA: %s, deleting.\n", sa);
+				    "klips_debug:ipsec_callback: "
+				    "EMT_SETSPI not successful for SA: %s, deleting.\n",
+				    sa_len ? sa : " (error)");
 			ipsec_tdbwipe(tdbp);
 			
 			SENDERR(-error);
@@ -234,7 +248,9 @@
 
 		puttdb(tdbp);
 		KLIPS_PRINT(debug_netlink & DB_NL_TDBCB,
-			    "klips_debug:ipsec_callback: EMT_SETSPI successful for SA: %s\n", sa);
+			    "klips_debug:ipsec_callback: "
+			    "EMT_SETSPI successful for SA: %s\n",
+			    sa_len ? sa : " (error)");
 		break;
 		
 	case EMT_DELSPI:
@@ -247,8 +263,8 @@
 		if (tdbp == NULL) {
 			KLIPS_PRINT(debug_netlink & DB_NL_TDBCB,
 				    "klips_debug:ipsec_callback: "
-				    "EMT_DELSPI Tunnel Descriptor Block not found for SA:\n"
-				    "klips_debug:                %s, could not delete.\n", sa);
+				    "EMT_DELSPI Tunnel Descriptor Block not found for SA%s, could not delete.\n",
+				    sa_len ? sa : " (error)");
 			spin_unlock_bh(&tdb_lock);
 			SENDERR(ENXIO);  /* XXX -- wrong error message... */
 		} else {
@@ -264,7 +280,8 @@
 	case EMT_GRPSPIS:
 		nspis = (len - EMT_GRPSPIS_FLEN) / sizeof(em->em_rel[0]);
 		if ((nspis * (sizeof(em->em_rel[0]))) != (len - EMT_GRPSPIS_FLEN)) {
-			printk("klips_debug:ipsec_callback: EMT_GRPSPI message size incorrect, expected nspis(%d)*%d, got %d.\n",
+			printk("klips_debug:ipsec_callback: "
+			       "EMT_GRPSPI message size incorrect, expected nspis(%d)*%d, got %d.\n",
 			       nspis,
 			       sizeof(em->em_rel[0]),
 			       (len - EMT_GRPSPIS_FLEN));
@@ -276,21 +293,23 @@
 
 		for (i = 0; i < nspis; i++) {
 			KLIPS_PRINT(debug_netlink,
-				    "klips_debug:ipsec_callback: EMT_GRPSPI for SA(%d)\n"
-				    "klips_debug:                %s,\n", i, sa);
+				    "klips_debug:ipsec_callback: "
+				    "EMT_GRPSPI for SA(%d) %s,\n",
+				    i,
+				    sa_len ? sa : " (error)");
 			if ((tdbp = gettdb(&(em->em_rel[i].emr_said))) == NULL) {
 				KLIPS_PRINT(debug_netlink,
 					    "klips_debug:ipsec_callback: "
-					    "EMT_GRPSPI Tunnel Descriptor Block not found for SA:\n"
-					    "klips_debug:                %s, could not group.\n", sa);
+					    "EMT_GRPSPI Tunnel Descriptor Block not found for SA%s, could not group.\n",
+					    sa_len ? sa : " (error)");
 				spin_unlock_bh(&tdb_lock);
 				SENDERR(ENXIO);
 			} else {
 				if(tdbp->tdb_inext || tdbp->tdb_onext) {
 					KLIPS_PRINT(debug_netlink,
 						    "klips_debug:ipsec_callback: "
-						    "EMT_GRPSPI Tunnel Descriptor Block already grouped\n"
-						    "klips_debug:                for SA: %s, can't regroup.\n", sa);
+						    "EMT_GRPSPI Tunnel Descriptor Block already grouped for SA: %s, can't regroup.\n",
+						    sa_len ? sa : " (error)");
 					spin_unlock_bh(&tdb_lock);
 					SENDERR(EBUSY);
 				}
@@ -327,8 +346,8 @@
 		if ((tdbp = gettdb(&(em->em_rel[0].emr_said))) == NULL) {
 			KLIPS_PRINT(debug_netlink,
 				    "klips_debug:ipsec_callback: "
-				    "EMT_UGRPSPI Tunnel Descriptor Block not found for SA:\n"
-				    "klips_debug:                %s, could not ungroup.\n", sa);
+				    "EMT_UGRPSPI Tunnel Descriptor Block not found for SA%s, could not ungroup.\n",
+				    sa_len ? sa : " (error)");
 			spin_unlock_bh(&tdb_lock);
 			SENDERR(ENXIO);
 		}
@@ -348,14 +367,16 @@
 		
 	case EMT_CLRSPIS:
 		KLIPS_PRINT(debug_netlink,
-			    "klips_debug:ipsec_callback: spi clear called.\n");
+			    "klips_debug:ipsec_callback: "
+			    "spi clear called.\n");
 		if (em->em_if >= 5)	/* XXX -- why 5? */
 			SENDERR(ENODEV);
 		ipsec_tdbcleanup(0);
 		break;
 	default:
 		KLIPS_PRINT(debug_netlink,
-			    "klips_debug:ipsec_callback: unknown message type\n");
+			    "klips_debug:ipsec_callback: "
+			    "unknown message type\n");
 		SENDERR(EINVAL);
 	}
  errlab:
@@ -370,6 +391,10 @@
 
 /*
  * $Log: ipsec_netlink.c,v $
+ * Revision 1.48  2001/02/27 22:24:54  rgb
+ * Re-formatting debug output (line-splitting, joining, 1arg/line).
+ * Check for satoa() return codes.
+ *
  * Revision 1.47  2000/11/06 04:32:08  rgb
  * Ditched spin_lock_irqsave in favour of spin_lock_bh.
  *
diff -bruN freeswan-1.9.orig/klips/net/ipsec/ipsec_radij.c freeswan-1.9/klips/net/ipsec/ipsec_radij.c
--- freeswan-1.9.orig/klips/net/ipsec/ipsec_radij.c	Sun Nov  5 23:32:08 2000
+++ freeswan-1.9/klips/net/ipsec/ipsec_radij.c	Mon Jun  4 12:54:13 2001
@@ -13,7 +13,7 @@
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
  *
- * RCSID $Id: ipsec_radij.c,v 1.41 2000/11/06 04:32:08 rgb Exp $
+ * RCSID $Id: ipsec_radij.c,v 1.45 2001/05/27 06:12:11 rgb Exp $
  */
 
 #include <linux/config.h>
@@ -54,7 +54,7 @@
 int debug_radij = 0;
 #endif /* CONFIG_IPSEC_DEBUG */
 
-struct radij_node_head *rnh = 0;
+struct radij_node_head *rnh = NULL;
 #ifdef SPINLOCK
 spinlock_t eroute_lock = SPIN_LOCK_UNLOCKED;
 #else /* SPINLOCK */
@@ -68,7 +68,7 @@
 
 	rj_init();
 	
-	if (rj_inithead((void **)&rnh, 16) == 0) /* 16 is bit offset of sen_type */
+	if (rj_inithead((void **)&rnh, /*16*/offsetof(struct sockaddr_encap, sen_type) * sizeof(__u8)) == 0) /* 16 is bit offset of sen_type */
 		return -1;
 	return 0;
 }
@@ -90,7 +90,7 @@
 int
 ipsec_cleareroutes(void)
 {
-	int error;
+	int error = 0;
 
 	spin_lock_bh(&eroute_lock);
 
@@ -105,15 +105,18 @@
 ipsec_breakroute(struct sockaddr_encap *eaddr, struct sockaddr_encap *emask)
 {
 	struct radij_node *rn;
-	int error;
+	int error = 0;
 #ifdef CONFIG_IPSEC_DEBUG
 	char buf1[64], buf2[64];
 	
 	if (debug_eroute) {
 		subnettoa(eaddr->sen_ip_src, emask->sen_ip_src, 0, buf1, sizeof(buf1));
 		subnettoa(eaddr->sen_ip_dst, emask->sen_ip_dst, 0, buf2, sizeof(buf2));
-		printk("klips_debug:ipsec_breakroute: attempting to delete eroute for %s->%s\n",
-			       buf1, buf2);
+		KLIPS_PRINT(debug_eroute, 
+			    "klips_debug:ipsec_breakroute: "
+			    "attempting to delete eroute for %s->%s\n",
+			    buf1,
+			    buf2);
 	}
 #endif /* CONFIG_IPSEC_DEBUG */
 
@@ -121,7 +124,8 @@
 
 	if ((error = rj_delete(eaddr, emask, rnh, &rn)) != 0) {
 		spin_unlock_bh(&eroute_lock);
-		KLIPS_PRINT(debug_eroute, "klips_debug:ipsec_breakroute: "
+		KLIPS_PRINT(debug_eroute, 
+			    "klips_debug:ipsec_breakroute: "
 			    "node not found, eroute delete failed.\n");
 		return error;
 	}
@@ -138,10 +142,10 @@
 }
 
 int
-ipsec_makeroute(struct sockaddr_encap *eaddr, struct sockaddr_encap *emask, struct sa_id said)
+ipsec_makeroute(struct sockaddr_encap *eaddr, struct sockaddr_encap *emask, struct sa_id said, uint32_t pid)
 {
 	struct eroute *retrt;
-	int error;
+	int error = 0;
 	char sa[SATOA_BUF];
 	size_t sa_len;
 #ifdef CONFIG_IPSEC_DEBUG
@@ -151,14 +155,20 @@
 		subnettoa(eaddr->sen_ip_src, emask->sen_ip_src, 0, buf1, sizeof(buf1));
 		subnettoa(eaddr->sen_ip_dst, emask->sen_ip_dst, 0, buf2, sizeof(buf2));
 		sa_len = satoa(said, 0, sa, SATOA_BUF);
-		printk("klips_debug:ipsec_makeroute: attempting to insert eroute for %s->%s, SA: %s\n",
-		       buf1, buf2, sa);
+		KLIPS_PRINT(debug_eroute, 
+			    "klips_debug:ipsec_makeroute: "
+			    "attempting to insert eroute for %s->%s, SA: %s, PID:%d\n",
+			    buf1,
+			    buf2,
+			    sa_len ? sa : " (error)",
+			    pid);
 	}
 #endif /* CONFIG_IPSEC_DEBUG */
 
 	retrt = (struct eroute *)kmalloc(sizeof (struct eroute), GFP_ATOMIC);
 	if (retrt == NULL) {
-		printk("klips_error:ipsec_makeroute: not able to allocate kernel memory");
+		printk("klips_error:ipsec_makeroute: "
+		       "not able to allocate kernel memory");
 		return ENOMEM;
 	}
 	memset((caddr_t)retrt, 0, sizeof (struct eroute));
@@ -166,6 +176,9 @@
 	retrt->er_eaddr = *eaddr;
 	retrt->er_emask = *emask;
 	retrt->er_said = said;
+	retrt->er_pid = pid;
+	retrt->er_count = 0;
+	retrt->er_lasttime = jiffies/HZ;
 	rd_key((&(retrt->er_rjt))) = &(retrt->er_eaddr);
 	
 	spin_lock_bh(&eroute_lock);
@@ -177,12 +190,40 @@
 	
 	if(error) {
 		sa_len = satoa(said, 0, sa, SATOA_BUF);
-		printk("klips_debug:ipsec_makeroute: rj_addroute not able to insert eroute for SA:%s\n", sa);
+		KLIPS_PRINT(debug_eroute, 
+			    "klips_debug:ipsec_makeroute: "
+			    "rj_addroute not able to insert eroute for SA:%s\n",
+			    sa_len ? sa : " (error)");
 		kfree(retrt); /* XXX -- should we? */
 		return error;
 	}
+
+	if (debug_eroute && 0) {
+/*
+		subnettoa(eaddr->sen_ip_src, emask->sen_ip_src, 0, buf1, sizeof(buf1));
+		subnettoa(eaddr->sen_ip_dst, emask->sen_ip_dst, 0, buf2, sizeof(buf2));
+*/
+		subnettoa(rd_key((&(retrt->er_rjt)))->sen_ip_src, rd_mask((&(retrt->er_rjt)))->sen_ip_src, 0, buf1, sizeof(buf1));
+		subnettoa(rd_key((&(retrt->er_rjt)))->sen_ip_dst, rd_mask((&(retrt->er_rjt)))->sen_ip_dst, 0, buf2, sizeof(buf2));
+		sa_len = satoa(retrt->er_said, 0, sa, SATOA_BUF);
+		
 	KLIPS_PRINT(debug_eroute,
-		    "klips_debug:ipsec_makeroute: succeeded, I think...\n");
+			    "klips_debug:ipsec_makeroute: "
+			    "pid=%05d "
+			    "count=%10d "
+			    "lasttime=%6d "
+			    "%-18s -> %-18s => %s\n",
+			    retrt->er_pid,
+			    retrt->er_count,
+			    (int)(jiffies/HZ - retrt->er_lasttime),
+			    buf1,
+			    buf2,
+			    sa_len ? sa : " (error)");
+	}
+
+	KLIPS_PRINT(debug_eroute,
+		    "klips_debug:ipsec_makeroute: "
+		    "succeeded, I think...\n");
 	return 0;
 }
 
@@ -196,11 +237,22 @@
 	if (debug_radij & DB_RJ_FINDROUTE) {
 		addrtoa(eaddr->sen_ip_src, 0, buf1, sizeof(buf1));
 		addrtoa(eaddr->sen_ip_dst, 0, buf2, sizeof(buf2));
-		printk("klips_debug:ipsec_findroute: %s->%s\n",
-		       buf1, buf2);
+		KLIPS_PRINT(debug_eroute,
+			    "klips_debug:ipsec_findroute: "
+			    "%s->%s\n",
+			    buf1,
+			    buf2);
 	}
 #endif /* CONFIG_IPSEC_DEBUG */
 	rn = rj_match((caddr_t)eaddr, rnh);
+	if(rn) {
+		KLIPS_PRINT(debug_eroute,
+			    "klips_debug:ipsec_findroute: "
+			    "found, points to proto=%d, spi=%x, dst=%x.\n",
+			    ((struct eroute*)rn)->er_said.proto,
+			    ntohl(((struct eroute*)rn)->er_said.spi),
+			    ntohl(((struct eroute*)rn)->er_said.dst.s_addr));
+	}
 	return (struct eroute *)rn;
 }
 		
@@ -217,8 +269,10 @@
 	struct sockaddr_encap *key, *mask;
 	
 	KLIPS_PRINT(debug_radij,
-		    "klips_debug:ipsec_rj_walker_procprint: rn=%p, w0=%p\n",
-		    rn, w0);
+		    "klips_debug:ipsec_rj_walker_procprint: "
+		    "rn=%p, w0=%p\n",
+		    rn,
+		    w0);
 	if (rn == NULL)	{
 		return 120;
 	}
@@ -238,8 +292,24 @@
 	subnettoa(key->sen_ip_dst, mask->sen_ip_dst, 0, buf2, sizeof(buf2));
 	sa_len = satoa(ro->er_said, 0, sa, SATOA_BUF);
 	w->len += sprintf(w->buffer + w->len,
+/*
+			  "%05d "
+*/
+			  "%-10d "
+/*
+			  "%6d "
+*/
 			  "%-18s -> %-18s => %s\n",
-			  buf1, buf2, sa);
+/*
+			  ro->er_pid,
+*/
+			  ro->er_count,
+/*
+			  jiffies / HZ - ro->er_lasttime,
+*/
+			  buf1,
+			  buf2,
+			  sa_len ? sa : " (error)");
 	
 	w->pos = w->begin + w->len;
 	if(w->pos < w->offset) {
@@ -258,7 +328,7 @@
 {
 	struct rjtentry *rd = (struct rjtentry *)rn;
 	struct radij_node *rn2;
-	int error;
+	int error = 0;
 	struct sockaddr_encap *key, *mask;
 #ifdef CONFIG_IPSEC_DEBUG
 	char buf1[64] = { 0 }, buf2[64] = { 0 };
@@ -272,14 +342,17 @@
 	mask = rd_mask(rd);
 	
 	if(!key || !mask) {
-		return -1;
+		return -ENODATA;
 	}
 #ifdef CONFIG_IPSEC_DEBUG
 	if(debug_radij)	{
 		subnettoa(key->sen_ip_src, mask->sen_ip_src, 0, buf1, sizeof(buf1));
 		subnettoa(key->sen_ip_dst, mask->sen_ip_dst, 0, buf2, sizeof(buf2));
-		printk("klips_debug:ipsec_rj_walker_delete: deleting: %s -> %s\n",
-		       buf1, buf2);
+		KLIPS_PRINT(debug_radij, 
+			    "klips_debug:ipsec_rj_walker_delete: "
+			    "deleting: %s -> %s\n",
+			    buf1,
+			    buf2);
 	}
 #endif /* CONFIG_IPSEC_DEBUG */
 
@@ -291,8 +364,8 @@
 	}
 
 	if(rn2 != rn) {
-		printk("klips_debug:ipsec_rj_walker_delete: tried to delete a different node?!?"
-		       "This should never happen!\n");
+		printk("klips_debug:ipsec_rj_walker_delete: "
+		       "tried to delete a different node?!?  This should never happen!\n");
 	}
 	memset((caddr_t)rn, 0, sizeof (struct eroute));
 	kfree(rn);
@@ -302,6 +375,21 @@
 
 /*
  * $Log: ipsec_radij.c,v $
+ * Revision 1.45  2001/05/27 06:12:11  rgb
+ * Added structures for pid, packet count and last access time to eroute.
+ * Added packet count to beginning of /proc/net/ipsec_eroute.
+ *
+ * Revision 1.44  2001/05/03 19:41:01  rgb
+ * Initialise error return variable.
+ * Use more appropriate return value for ipsec_rj_walker_delete().
+ *
+ * Revision 1.43  2001/02/27 22:24:54  rgb
+ * Re-formatting debug output (line-splitting, joining, 1arg/line).
+ * Check for satoa() return codes.
+ *
+ * Revision 1.42  2001/02/27 06:21:57  rgb
+ * Added findroute success instrumentation.
+ *
  * Revision 1.41  2000/11/06 04:32:08  rgb
  * Ditched spin_lock_irqsave in favour of spin_lock_bh.
  *
diff -bruN freeswan-1.9.orig/klips/net/ipsec/ipsec_radij.h freeswan-1.9/klips/net/ipsec/ipsec_radij.h
--- freeswan-1.9.orig/klips/net/ipsec/ipsec_radij.h	Fri Sep  8 15:12:56 2000
+++ freeswan-1.9/klips/net/ipsec/ipsec_radij.h	Mon Jun  4 12:54:13 2001
@@ -13,7 +13,7 @@
  * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  * for more details.
  *
- * RCSID $Id: ipsec_radij.h,v 1.11 2000/09/08 19:12:56 rgb Exp $
+ * RCSID $Id: ipsec_radij.h,v 1.12 2001/05/27 06:12:11 rgb Exp $
  */
 
 #include <freeswan.h>
@@ -34,14 +34,8 @@
 	off_t pos;
 };
 
-#if 0
-struct eroute * ipsec_makeroute(struct sockaddr_encap *ea, struct sockaddr_encap *em, struct sa_id);
-#endif
-int ipsec_makeroute(struct sockaddr_encap *ea, struct sockaddr_encap *em, struct sa_id);
-
-#if 0
-struct eroute * ipsec_breakroute(struct sockaddr_encap *ea, struct sockaddr_encap *em);
-#endif
+int ipsec_makeroute(struct sockaddr_encap *ea, struct sockaddr_encap *em, struct sa_id, uint32_t pid);
+
 int ipsec_breakroute(struct sockaddr_encap *ea, struct sockaddr_encap *em);
 
 int ipsec_radijinit(void);
@@ -68,6 +62,10 @@
 
 /*
  * $Log: ipsec_radij.h,v $
+ * Revision 1.12  2001/05/27 06:12:11  rgb
+ * Added structures for pid, packet count and last access time to eroute.
+ * Added packet count to beginning of /proc/net/ipsec_eroute.
+ *
  * Revision 1.11  2000/09/08 19:12:56  rgb
  * Change references from DEBUG_IPSEC to CONFIG_IPSEC_DEBUG.
  *
